// pages/release/release.js
// 获取应用实例
const app = getApp()
const $request = require('../../utils/request.js');
const $util = require('../../utils/util.js');
Page({
    data: {
        currentIndex: 2,
        pageLoading: true,
        customerId: "",
        // 前往关注公众号
        topShow: true,
        msgData: [],
        page: 1,
        size: 10,
        total: 0,
        // 是否加载数据，true加载，false不加载
        onRefresh: true,
    },
    /**
      * 生命周期函数--监听页面加载
      */
    onLoad() {
        const businessCommunicationCustomer = wx.getStorageSync('businessCommunicationCustomer') || null;
        if (businessCommunicationCustomer) {
            this.setData({
                customerId: businessCommunicationCustomer.customerId
            })
        }
        // 初始化websocket
        this.initWebSocket();
    },
    onShow() {
        // 初始化数据
        this.initData();
    },
    //  websocket初始化
    initWebSocket: function () {
        var _this = this;
        let { customerId } = _this.data;
        // console.log()
        //建立连接
        wx.connectSocket({
            url: `ws://192.168.18.138/webSocket/{"userno":${customerId},"messageModule":"010"}`,//本地
            success: function () {
                console.log('消息页-websocket连接成功~')
            },
            fail: function () {
                console.log('消息页-websocket连接失败~')
            },
        })

        //连接成功
        wx.onSocketOpen(function () {
            console.log('消息页-连接成功,真正的成功', 'onSocketOpen');
        })

        //  接收服务器的消息事件
        wx.onSocketMessage(function (res) {
            // 接收到的消息{date,message,type}  type类型为 1 是对方的消息 为 0 是自己的消息
            console.log(res,'消息页----收到新消息')
            _this.initData();
        })

        //  监听连接关闭
        wx.onSocketClose(function () {
            console.log('监听 WebSocket 连接关闭事件')
        })

    },
    // 关闭顶部关注
    closeTopShow() {
        this.setData({
            topShow: false
        })
    },
    // 聊一聊
    goToChat(e) {

        let item = e.currentTarget.dataset.item;
        wx.navigateTo({
            url: "/pages/msgModule/wechat2/wechat2",
            success: function (res) {
                // 通过eventChannel向被打开页面传送数据
                res.eventChannel.emit('customerid', { customerid: item.businessCommunicationCustomerVO.customerId, chatHeads: item.businessCommunicationCustomerVO.chatHeads })
            }
        })
    },
    initData() {
        this.setData({
            page: 1,
            size: 10,
            msgData: [],
        })
        this.getMsgData();
    },
    getMsgData() {
        let { page, size } = this.data;
        $request.get('/businessCommunicationDemand/getChatRecordTable.action', { page, size }).then(res => {
            let tempListData = this.data.msgData;
            if (res.status == 0) {
                let datas = res.data;
                // 先push数据
                tempListData.push(...datas.chatRecordTable);
                tempListData.forEach(el => {
                    el.lastContentDate = $util.formatTime(new Date(el.lastContentDate));
                    el.lastContentDate = el.lastContentDate.replaceAll('/', '-');
                    if (typeof el.type == 'string') {
                        el.type = el.type.split(',');
                    }
                })
                // 设置总数
                this.setData({
                    msgData: tempListData,
                    total: datas.total,
                })
                // 如果数据大于了返回的总数
                if (tempListData.length >= this.data.total) {
                    // 停止累加数据
                    this.setData({
                        onRefresh: false,
                        itemLoading: false,
                    })
                } else {
                    this.setData({
                        onRefresh: true,
                        itemLoading: false,
                        page: page + 1
                    })
                }
                console.log('-------------消息 beg-------------------')
                console.log(this.data.msgData);
                console.log('-------------消息 end-------------------')
            }
            this.setData({
                pageLoading: false,
            })
        }).catch(error => {
            console.log(error, 'error appletLogin')
        })

    },
    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom: function () {
        if (this.data.onRefresh) {
            this.setData({
                itemLoading: true
            })
            this.getListData();
        }
    },
})